registerToolbarItem
registerToolbarItem(key: string, component: SvelteComponent)
this helper allows to register custom components as elements in the toolbar
Usage
Register custom component as toolbar's element
<script>
import { Toolbar, registerToolbarItem } from "wx-svelte-toolbar";
import { Text } from "wx-svelte-core";
// register custom component
registerToolbarItem("text", Text);
</script>
<Toolbar
items={[
{ id: "label", text: "Toolbar with text input" },
{ id: "search", comp: "text" },
]}
/>
Create custom button control for toolbar
in myControl.svelte
<script>
export let menu;
export let text;
</script>
<button class:menu onclick>{text}</button>
<style>
.menu {
font-weight: bold;
}
</style>
- custom control can fire
onclick
event on activation menu
property will be set to true, when component is inside of popup menu- any other property set in the
item
object will be available
in App.svelte
<script>
import { Toolbar, registerToolbarItem } from "wx-svelte-toolbar";
import MyControl from "./MyControl.svelte";
// register custom component
registerToolbarItem("cb", MyControl);
</script>
<Toolbar
items={[
{ id: "label", text: "Toolbar with custom button" },
{ id: "search", comp: "cb" },
]}
/>
Create custom input control for toolbar
in myControl.svelte
<script>
export let value;
export let type = "text";
</script>
<input type="text" bind:value />
- value property will contain initial value
- changes to value will be reflected in toolbars state
- any other property set in the
item
object will be available
in App.svelte
<script>
import { Toolbar, registerToolbarItem } from "wx-svelte-toolbar";
import MyControl from "./MyControl.svelte";
// register custom component
registerToolbarItem("ci", MyControl);
</script>
<Toolbar
items={[
{ id: "label", text: "Toolbar with custom input" },
{ id: "search", comp: "ci", type: "search" },
]}
/>

Skip to main content

registerToolbarItem

Description

Registers custom components as elements in the toolbar

Usage

registerToolbarItem(type: string, handler: Component)<any>): void;

Parameters

The function accepts the following parameters:

  • type - the unique name that identifies the custom toolbar component.

  • handler - the Vue component that implements the custom toolbar item

Examples

Register custom component as toolbar's element

<script setup>
import { Toolbar, registerToolbarItem } from "@svar-ui/vue-toolbar";
import { Text } from "@svar-ui/vue-core";

// register custom component
registerToolbarItem("text", Text);
</script>

<template>
<Toolbar
:items="[
{ id: 'label', text: 'Toolbar with text input' },
{ id: 'search', comp: 'text' },
]"
/>
</template>

Create custom button control for toolbar

In myControl.vue

<script setup>
const props = defineProps({ menu: {}, text: {} });
const emit = defineEmits(["click"]);
</script>

<template>
<button :class="{ menu: props.menu }" @click="emit('click')">{{ props.text }}</button>
</template>

<style scoped>
.menu {
font-weight: bold;
}
</style>
  • custom control can fire onclick event on activation
  • menu property will be set to true, when component is inside of popup menu
  • any other property set in the item object will be available

In App.vue:

<script setup>
import { Toolbar, registerToolbarItem } from "@svar-ui/vue-toolbar";
import MyControl from "./MyControl.vue";

// register custom component
registerToolbarItem("cb", MyControl);
</script>

<template>
<Toolbar
:items="[
{ id: 'label', text: 'Toolbar with custom button' },
{ id: 'search', comp: 'cb' },
]"
/>
</template>

Create custom input control for toolbar

In myControl.vue:

<script setup>
const value = defineModel('value');
const props = defineProps({ type: { default: 'text' } });
</script>

<template>
<input type="text" v-model="value" />
</template>
  • value property will contain initial value
  • changes to value will be reflected in toolbars state
  • any other property set in the item object will be available

In App.vue:

<script setup>
import { Toolbar, registerToolbarItem } from "@svar-ui/vue-toolbar";
import MyControl from "./MyControl.vue";

// register custom component
registerToolbarItem("ci", MyControl);
</script>

<template>
<Toolbar
:items="[
{ id: 'label', text: 'Toolbar with custom input' },
{ id: 'search', comp: 'ci', type: 'search' },
]"
/>
</template>

registerToolbarItem
Description
Registers a React component under a given type name so it can be referenced from Toolbar items. After registration, the toolbar will instantiate the provided component when an item uses the corresponding comp/type identifier.
Usage
registerToolbarItem(type: string, handler: React.ComponentType<any>): void;
Parameters
The function accepts the following parameters:
-
type- the unique name that identifies the custom toolbar component. -
handler- the React component that implements the custom toolbar item
Examples
Register custom component as toolbar's element
import { Toolbar, registerToolbarItem } from "@svar-ui/react-toolbar";
import { Text } from "@svar-ui/react-core";
// register custom component
registerToolbarItem("text", Text);
<Toolbar
items={[
{ id: "label", text: "Toolbar with text input" },
{ id: "search", comp: "text" },
]}
/>
Create custom button control for toolbar
In MyControl.jsx
export default function MyControl({ menu, text, onClick }) {
return (
<button className={menu ? "menu" : ""} onClick={onClick}>
{text}
</button>
);
}
.my-control.css
.menu {
font-weight: bold;
}
- custom control can fire
onClickevent on activation menuproperty will be set to true when the component is inside of a popup menu- any other property set in the
itemobject will be available as a prop
In App.jsx:
import { Toolbar, registerToolbarItem } from "@svar-ui/react-toolbar";
import MyControl from "./MyControl.jsx";
// register custom component
registerToolbarItem("cb", MyControl);
<Toolbar
items={[
{ id: "label", text: "Toolbar with custom button" },
{ id: "search", comp: "cb" },
]}
/>
Create custom input control for toolbar
In MyControl.jsx:
export default function MyControl({ value, onChange, type = "text" }) {
return (
<input
type={type}
value={value}
onChange={(e) => onChange(e.target.value)}
/>
);
}
valueproperty will contain initial value- changes to value must be propagated via
onChangeand will be reflected in the toolbar's state - any other property set in the
itemobject will be available as a prop
In App.jsx:
import { Toolbar, registerToolbarItem } from "@svar-ui/react-toolbar";
import MyControl from "./MyControl.jsx";
// register custom component
registerToolbarItem("ci", MyControl);
<Toolbar
items={[
{ id: "label", text: "Toolbar with custom input" },
{ id: "search", comp: "ci", type: "search" },
]}
/>